#!/bin/bash

mapfile -t isolated < isolated_tests
mapfile -t excluded < excluded_tests

get_tests () {
  mapfile -t tests < <( find spec/*_spec.rb | awk -F/ '{print $NF}' )
  mapfile -t isolated < isolated_tests
  mapfile -t excluded < excluded_tests
  local result=()
  for item in "${tests[@]}"; do
    remove=false
    # Check if the item is in the isolated tests
    for remove_isolated in "${isolated[@]}"; do
      if [[ "$item" == "$remove_isolated" ]]; then
          remove=true
          break
      fi
    done

    # Check if the item is in the excluded tests
    for remove_excluded in "${excluded[@]}"; do
      if [[ "$item" == "$remove_excluded" ]]; then
          remove=true
          break
      fi
    done

    # If the item is not found in the remove arrays, add it to the result array
    if [ "$remove" = false ]; then
        result+=("$item")
    fi
  done
  echo "${result[@]}"
}

get_isolated_tests () {
  mapfile -t isolated < isolated_tests
  mapfile -t excluded < excluded_tests
  local result=()
  for item in "${isolated[@]}"; do
    remove=false
    # Check if the item is in the excluded tests
    for remove_excluded in "${excluded[@]}"; do
      if [[ "$item" == "$remove_excluded" ]]; then
          remove=true
          break
      fi
    done

    # If the item is not found in the remove arrays, add it to the result array
    if [ "$remove" = false ]; then
        result+=("$item")
    fi
  done
  echo "${result[@]}"
}

if [ "$1" == "isolated" ]; then
  get_isolated_tests
elif [ "$1" == "excluded" ]; then
  mapfile -t excluded < excluded_tests
  echo "${excluded[@]}"
else
  get_tests
fi


