=begin
 This file is part of Hopsworks
 Copyright (C) 2024, Hopsworks AB. All rights reserved

 Hopsworks is free software: you can redistribute it and/or modify it under the terms of
 the GNU Affero General Public License as published by the Free Software Foundation,
 either version 3 of the License, or (at your option) any later version.

 Hopsworks is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE.  See the GNU Affero General Public License for more details.

 You should have received a copy of the GNU Affero General Public License along with this program.
 If not, see <https://www.gnu.org/licenses/>.
=end
module KubectlHelper

  @@kube_user = Variables.find_by(id: "kube_user")&.value

  def kubectl_cmd(cmd, namespace: nil, out_put: "")
    ns = ""
    unless namespace.nil?
      ns = "--namespace=#{namespace}"
    end
    if ENV['KUBE_CLUSTER'] == "true"
      "kubectl #{cmd} #{ns} #{out_put}"
    else
      "sudo su #{@@kube_user} /bin/bash -c \"kubectl #{cmd} #{ns} #{out_put} \""
    end
  end

  def run_kubectl_cmd(cmd, namespace: nil, out_put: "")
    Open3.popen3(kubectl_cmd(cmd, namespace: namespace, out_put: out_put)) { |_, stdout, _, _| stdout.read }
  end
end